/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */

package org.glassfish.cditest.user.api;

import javax.ejb.EJBException;
import org.glassfish.cditest.user.api.model.User;

/**
 * <p>
 * Manage user-related data
 * </p>
 * 
 * <p>
 * A service that implements this interface is responsible for managing
 * user-related master-data
 * </p>
 * 
 * @author kane
 * 
 * @see User
 */
public interface UserService
{
    
    /**
     * <p>
     * Get a {@link User} by the user id
     * </p>
     * 
     * @param userid
     *            The userid to search for
     * @return A {@link User} object or <code>null</code> if no user was found
     */
    public User findById(long userId) throws EJBException;

    /**
     * <p>
     * Add a new user
     * </p>
     * 
     * <p>
     * The implementation must ensure that the provided user object is persisted
     * before returning the assigned persistent user ID.
     * </p>
     * 
     * @param user
     *            The user object to persist
     * @return The newly created persistent ID of the user object
     * 
     * @see User
     */
    public Long addUser(User user) throws EJBException;
}
