package org.glassfish.cditest.user.impl.ws;

import org.glassfish.cditest.user.impl.ws.client.UserClient;
import com.thoughtworks.xstream.XStream;
import javax.annotation.Resource;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.xml.ws.WebServiceException;
import org.glassfish.cditest.user.api.UserService;
import org.glassfish.cditest.user.api.model.User;
import org.glassfish.cditest.user.model.UserImpl;

@WebService()
public class UserServiceWS {

    @Resource
    private UserService svc;

    @WebMethod
    public UserClient findById(long arg0) throws UserServiceFaultException {
        UserClient result = new UserClient();
        Object tmp;
        try {
            tmp = svc.findById(arg0);
        } catch (Exception ex) {
            throw new UserServiceFaultException(ex.getMessage(), ex);
        }
        try {
            result = (UserClient) clientToWS(tmp);
        } catch (Exception x) {
            throw new WebServiceException("Unable to copy bean data (target type UserClient)", x);
        }

        return result;
    }

    @WebMethod
    public Long addUser(UserClient arg0) throws UserServiceFaultException {
        UserImpl arg0Copy = new UserImpl();
        try {
            arg0Copy = (UserImpl) wsToClient(arg0);
        } catch (Exception x) {
            throw new WebServiceException("Unable to copy bean data (target type UserImpl)", x);
        }
        Long result;
        try {
            result = svc.addUser(arg0Copy);
        } catch (Exception ex) {
            throw new UserServiceFaultException(ex.getMessage(), ex);
        }
        return result;
    }

    private Object wsToClient(final Object o) {
        XStream x = new XStream();
        XStream xCopy = new XStream();
        x.setMode(XStream.XPATH_ABSOLUTE_REFERENCES);
        xCopy.setMode(XStream.XPATH_ABSOLUTE_REFERENCES);
        x.addDefaultImplementation(UserClient.class, User.class);
        x.alias("user", UserClient.class);
        xCopy.addDefaultImplementation(UserImpl.class, User.class);
        xCopy.alias("user", UserImpl.class);

        return xCopy.fromXML(x.toXML(o));
    }

    private Object clientToWS(final Object o) {
        XStream x = new XStream();
        XStream xCopy = new XStream();
        x.setMode(XStream.XPATH_ABSOLUTE_REFERENCES);
        xCopy.setMode(XStream.XPATH_ABSOLUTE_REFERENCES);
        x.addDefaultImplementation(UserClient.class, User.class);
        x.alias("user", UserClient.class);
        xCopy.addDefaultImplementation(UserImpl.class, User.class);
        xCopy.alias("user", UserImpl.class);

        return x.fromXML(xCopy.toXML(o));
    }
}
